<!--
{% comment %}
Copyright 2018-2022 Elyra Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
{% endcomment %}
-->
<h1 align="center">Elyra Pipeline Editor</h1>

<p align="center">
  <img alt="Pipeline Editor" src="./images/banner.svg">
</p>

<p align="center">
  A react component for editing pipeline files. Used across all Elyra applications and browser extensions.
</p>

<p align="center">
  <a href="https://www.npmjs.com/package/@elyra/pipeline-editor"><img alt="NPM Status" src="https://img.shields.io/npm/v/@elyra/pipeline-editor.svg?style=flat"></a>
  <a href="https://github.com/elyra-ai/pipeline-editor/actions?query=branch%3Amaster+workflow%3AElyra%20Pipeline%20Editor%20Tests"><img alt="Test Status" src="https://github.com/elyra-ai/pipeline-editor/workflows/Elyra%20Pipeline%20Editor%20Tests/badge.svg?branch=master"></a>
</p>

## Installation

`@elyra/pipeline-editor` is available as an [npm package](https://www.npmjs.com/package/@elyra/pipeline-editor):

```sh
// npm
npm install @elyra/pipeline-editor

// yarn
yarn add @elyra/pipeline-editor
```

Or can be built and linked locally:

```sh
git clone git@github.com:elyra-ai/pipeline-editor.git
cd pipeline-editor

make clean install dev-link
```

Then in the project you're using the local build run the following:

```sh
yarn link @elyra/pipeline-editor @elyra/pipeline-services
```

or if you're running with Elyra you can use make:

```sh
make clean dev-link install
```

## Usage

```jsx
import { PipelineEditor } from "@elyra/pipeline-editor";

function App() {
  const [pipeline, setPipeline] = useState();
  return (
    <PipelineEditor pipeline={pipeline} palette={{}} onChange={setPipeline} />
  );
}
```
